﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlClient;
using System.Data;
using System.IO;

public partial class Admin_ManageTicket : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            if (Session["adminLI"].Equals(null))
            {
                Response.Redirect("AdminLogin.aspx");
            }
        }
        catch (Exception)
        {
            Response.Redirect("AdminLogin.aspx");
        }

        if (!IsPostBack)
            BindGridData();
    }


    public void BindGridData()
    {
        string app_path = Request.PhysicalApplicationPath;
        DirectoryInfo di = new DirectoryInfo(app_path);
        FileInfo fi = new FileInfo(app_path + @"\InstallInfo.xml");

        SqlConnection connection =
            new SqlConnection(ConnectionStringProvider.ExtractFromXML(fi.FullName));
        connection.Open();
        DataTable dt = new DataTable();
        SqlDataAdapter adp = new SqlDataAdapter("select * from Ticket", connection);
        adp.Fill(dt);
        connection.Close();
        TicketList.DataSource = dt.DefaultView;
        TicketList.DataBind();
    }
    protected void TicketList_RowEditing(object sender, GridViewEditEventArgs e)
    {
        TicketList.EditIndex = e.NewEditIndex;
        BindGridData();
    }
    protected void TicketList_RowDeleting(object sender, GridViewDeleteEventArgs e)
    {
        string app_path = Request.PhysicalApplicationPath;
        DirectoryInfo di = new DirectoryInfo(app_path);
        FileInfo fi = new FileInfo(app_path + @"\InstallInfo.xml");

        if (TicketList.SelectedRow == null)
            return;
        //Collecting Information
        GridViewRow row = TicketList.SelectedRow;
        string ID = row.Cells[0].Text + "_" + row.Cells[1].Text;
        //Connection to Database
        SqlConnection con = new SqlConnection(ConnectionStringProvider.ExtractFromXML(fi.FullName));
        con.Open();
        SqlCommand DeleteCommand = new SqlCommand(
            "Delete from Ticket where TKID = N'" + ID + "'"
             , con);
        DeleteCommand.ExecuteNonQuery();        
        con.Close();
        BindGridData();
    }
    protected void ImageButton1_Click(object sender, ImageClickEventArgs e)
    {
        Response.Redirect("adNewTicket.aspx");
    }
    protected void ImageButton1_Click1(object sender, ImageClickEventArgs e)
    {
        if (TicketList.SelectedIndex < 0)
            return;
        GridViewRow r = TicketList.SelectedRow;
        string src = r.Cells[0].Text;
        string dst = r.Cells[1].Text;
        string price = r.Cells[2].Text;
          string date = r.Cells[3].Text;
          DateTime dt = DateTime.Parse(date);
        string year = dt.Year.ToString();
        string month = dt.Month.ToString();
        string day = dt.Day.ToString();
          string time = r.Cells[4].Text.TrimEnd(' ');
          int sp = time.IndexOf(':', 0);
        string h = sp >=0 ?  time.Substring(0, sp) : time;
        string m = sp >=0 ? time.Substring(time.IndexOf(':', 0) + 1, time.Length - time.IndexOf(':', 0)-1) : "";
        Response.Redirect("adEditTicket.aspx?src=" + src 
                          + "&dst=" + dst + "&price=" + price
                          + "&year=" + year + "&month=" + month
                          + "&day=" + day + "&h=" + h + "&m=" + m);
    }
}
