﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Xml;
using System.IO;

/// <summary>
/// Summary description for ConnectionStringProvider
/// </summary>
public class ConnectionStringProvider
{
	public ConnectionStringProvider()
	{
	
	}

    public static string ExtractFromXML(string Path)
    {
        string cs = "";        
        XmlDocument doc = new XmlDocument();
        doc.Load(Path);
        XmlElement root_node = doc.DocumentElement;
        XmlNode elServerName;
        XmlNode elDatabaseName;
        XmlNode elIntegratedSecurity;
        XmlNode elUserName = null;
        XmlNode elPass = null;

        elServerName = root_node.GetElementsByTagName("ServerName")[0];
        elDatabaseName = root_node.GetElementsByTagName("DatabaseName")[0];
        elIntegratedSecurity = root_node.GetElementsByTagName("IntegratedSecurity")[0];
        if (Convert.ToBoolean(elIntegratedSecurity.InnerText) == false)
        {
            elUserName = root_node.GetElementsByTagName("DatabaseUsername")[0];
            elPass = root_node.GetElementsByTagName("DatabasePass")[0];
        }
        cs += "Data Source=" + elServerName.InnerText + 
              ";Initial Catalog=" + elDatabaseName.InnerText;
        if (Convert.ToBoolean(elIntegratedSecurity.InnerText) == true)
        {
            cs += ";Integrated Security=True";
        }
        else
        {
            cs += ";Username=" + elUserName.InnerText;
            cs += ";Password=" + elPass.InnerText;
        }
        return cs;
    }

    public static string ExtractAdminEmail(string Path)
    {
        XmlDocument doc = new XmlDocument();
        doc.Load(Path);
        XmlElement root_node = doc.DocumentElement;
        XmlNode Email = root_node.GetElementsByTagName("AdminEmail")[0];
        return Email.InnerText;
    }

    public static string ExtractAdminPass(string Path)
    {
        XmlDocument doc = new XmlDocument();
        doc.Load(Path);
        XmlElement root_node = doc.DocumentElement;
        XmlNode Pass = root_node.GetElementsByTagName("AdminPass")[0];
        return Pass.InnerText;
    }
}
