﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.IO;
using System.Data.Sql;
using System.Data.SqlClient;
using System.Data;
using System.Xml;
using System.Security.Cryptography.Xml;

public partial class Install_install : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            Session["IS"]= true;
            btnCheck_Click(this, new EventArgs());
        }        
    }
    protected void btnCheck_Click(object sender, EventArgs e)
    {
        string app_path = Request.PhysicalApplicationPath;
        DirectoryInfo di = new DirectoryInfo(app_path);
        FileInfo fi = new FileInfo(app_path + @"\InstallInfo.xml");
        if (!fi.Exists)
        {
            fi.Create();
        }
        
         string str =
                @" 
                    <li> " + fi.Name + @"  </li> 
                ";

        if (fi.IsReadOnly)
        {
            prList.Style[HtmlTextWriterStyle.ListStyleImage] = "url(fail.gif)";
            prList.DataBind();
            prList.InnerHtml = str;
            Session["pr"] = "fail";
        }
        else
        {            
            prList.Style[HtmlTextWriterStyle.ListStyleImage] = "url(success.gif)";
            prList.InnerHtml = str;
            Session["pr"] = "success";
            Session["ConfigPath"]=fi.FullName;
        }
    }


    protected void dbRefresh_Click(object sender, EventArgs e)
    {
        DataTable dt = SqlDataSourceEnumerator.Instance.GetDataSources();        
        DataBases.DataSource = dt.DefaultView;
        DataBases.DataBind();
    }
    
    protected void DataBases_RowCommand(object sender, GridViewCommandEventArgs e)
    {
        string ServerName = "";
        if (DataBases.SelectedRow == null)      
            return;
        
            ServerName = DataBases.SelectedRow.Cells[0].Text + @"\SQLEXPRESS";
       
        Session["ServerName"] = ServerName;
        SqlConnection con = new
            SqlConnection(@"Data Source="+ ServerName
            + @";Integrated Security=True");
        con.Open();
        SqlCommand cmd_db_query = new SqlCommand(
                "select * from SYS.DATABASES",con);
        SqlDataReader dr = cmd_db_query.ExecuteReader();
        DataTable dbTable = new DataTable();
        DataColumn dc = new DataColumn("dbName");
        dbTable.Columns.Add(dc);
        while(dr.Read())
        {
            DataRow drow = dbTable.NewRow();
            drow[0] = dr.GetString(0);
            dbTable.Rows.Add(drow);
        }
        con.Close();
        DataBaseList.DataSource =  dbTable.DefaultView;
        DataBaseList.DataBind();
        if (dbTable.Rows.Count > 0)
        {
            dbCreate.Visible = true;
            txtdb.Visible = true;
        }
    }
    protected void dbCreate_Click(object sender, EventArgs e)
    {
        string ServerName = "";
        if (DataBases.SelectedRow == null)
            return;

        ServerName = DataBases.SelectedRow.Cells[0].Text + @"\SQLEXPRESS";
        SqlConnection con = new
            SqlConnection(@"Data Source=" + ServerName
            + @";Integrated Security=True");
        con.Open();
        SqlCommand cmd_db_query = new SqlCommand(
                @"select COUNT([name]) from SYS.DATABASES where [name] = '" + txtdb.Text + "'"
                , con);
        int count = (int) cmd_db_query.ExecuteScalar();
        if (count > 0)
        {
            con.Close();
            lblErr.ForeColor = System.Drawing.Color.Red;
            lblErr.Text = "پایگاه داده ای با این نام وجود دارد.";
            return;
        }
        else
        {
            lblErr.ForeColor = System.Drawing.Color.Green;            
            SqlCommand InsertCommand = new SqlCommand();
            InsertCommand.Connection = con;
            string cmdtext = "create database " + txtdb.Text;
            InsertCommand.CommandText = cmdtext;
            try
            {
                InsertCommand.ExecuteNonQuery();
                lblErr.Text = "پایگاه داده جدید ایجاد شد.";
                DataBaseList.DataBind();
                con.Close();
            }
            catch (Exception)
            {
                lblErr.ForeColor = System.Drawing.Color.Red;
                lblErr.Text = "خطا در ایجاد پایگاه داده";
            }
            finally
            {
                con.Close();
            }
        }
    }
    protected void DataBaseList_RowCommand(object sender, GridViewCommandEventArgs e)
    {
        string dbName = "";
        if (DataBaseList.SelectedRow == null)
            return;

        dbName = DataBaseList.SelectedRow.Cells[0].Text;

        Session["DatabaseName"] = dbName;
    }
    protected void RadioButton2_CheckedChanged(object sender, EventArgs e)
    {
           
    }
    protected void opg_SelectedIndexChanged(object sender, EventArgs e)
    {
        if (opg.SelectedIndex == 1)
            sqlatmod.Visible = true;
        else
            sqlatmod.Visible = false;
    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        if (opg.SelectedIndex == 0)
        {
            Session["IS"] = true; 
        } 
        else
        {
            Session["IS"] = false;
            Session["dbUser"] = txtUser.Text;
            Session["dbPass"] = txtPass.Text;
        }
    }

    protected void Install_Click(object sender, ImageClickEventArgs e)
    {
        lblMainErr.InnerHtml = "لطفا موارد زیر را بررسی کنید: " + "<br/>";
        if (((string)Session["pr"]) == "fail" || (string)Session["pr"] == null)
            lblMainErr.InnerHtml += " سطح دسترسی را بررسی کنید." + "<br/>";
        else if (Session["ServerName"] == null || Session["DatabaseName"] == null)
            lblMainErr.InnerHtml += " پایگاه داده مورد نظر خود را انتخاب کنید." + "<br/>";
        else if (Session["IS"] == null ||
            (((bool)Session["IS"]) == false
             && (Session["dbUser"] == null || Session["dbPass"] == null)))
            lblMainErr.InnerHtml += " نوع احراز هویت پایگاه داده را انتخاب کنید." + "<br/>";
        else
        {
            XmlDocument doc = new XmlDocument();
            doc.RemoveAll();

            //Create and Add root element
            XmlNode DeclarationNode = doc.CreateNode(XmlNodeType.XmlDeclaration, "", "");
            doc.AppendChild(DeclarationNode);
            XmlElement RootElement = doc.CreateElement("Installation");
            doc.AppendChild(RootElement);

            //create configuration setting
                
                //admin info

                
                XmlElement cfgAdminEmail = doc.CreateElement("AdminEmail");
                cfgAdminEmail.InnerText = txtMail.Text;

                XmlElement cfgAdminPass = doc.CreateElement("AdminPass");                
                cfgAdminPass.InnerText = txtPass.Text;                    
                //dbName cfg setting
                XmlElement cfgDatabaseName = doc.CreateElement("DatabaseName");
                cfgDatabaseName.InnerText = Session["DatabaseName"].ToString();
                
                //serverName cfg setting
                XmlElement cfgServerName = doc.CreateElement("ServerName");
                cfgServerName.InnerText = Session["ServerName"].ToString();

                XmlElement cfgAuthenticationMode = doc.CreateElement("IntegratedSecurity");
                XmlElement cfgdbUser = doc.CreateElement("DatabaseUsername");
                XmlElement cfgdbPass = doc.CreateElement("DatabasePass");
                XmlElement cfgInstallationState = doc.CreateElement("Installed");

                cfgAuthenticationMode.InnerText = Session["IS"].ToString();
                try
                {                    
                    cfgdbUser.InnerText = Session["dbUser"].ToString();
                    cfgdbPass.InnerText = Session["dbPass"].ToString();
                }
                catch (Exception) { }

                cfgInstallationState.InnerText = "True";

                RootElement.AppendChild(cfgDatabaseName);
                RootElement.AppendChild(cfgServerName);
                RootElement.AppendChild(cfgAuthenticationMode);
                RootElement.AppendChild(cfgdbUser);
                RootElement.AppendChild(cfgdbPass);
                RootElement.AppendChild(cfgInstallationState);
                RootElement.AppendChild(cfgAdminEmail);
                RootElement.AppendChild(cfgAdminPass);
               
                    try
                    {
                        doc.Save(Session["ConfigPath"].ToString());
                        Response.Redirect("Success.aspx");
                    }
                    catch(Exception exception)
                    {
                        Response.Write("<br/>");
                        Response.Write("Error : " + exception.Message);                       
                    }
        }
    }
}
